#import <appkit/appkit.h>
#import "DiagramItem.h"

@class DiagramCell,Block,Socket,Post;

@interface Connection: DiagramItem

	#define UH_SOLIDLINE 0
	#define UH_DOTLINE 1
	#define UH_DASHLINE 2
	#define UH_DOTDASHLINE 3

{         
	Socket *head;			//socket at the head of the connection
	Socket *tail;			//socket at the tail of the connection
	DiagramCell *headCell;		//cell owning the head socket
	DiagramCell *tailCell;		//cell owning the tail socket
	NXPoint headCoords;	//cached coordinates of the head
	NXPoint tailCoords;	//cached coordinates of the tail
	float lineWidth;		//line width of the connection
	float labelFraction;	//fraction along the connection for label position
	float labelOffset;      //offset of label perpendicular to the connection
	int lineType;			//type of the connection
	NXColor color;			//color of the connection
	BOOL finished;		//indicates if connection has finished instantiation
	BOOL headArrow;		//indicates if head arrowhead is visible
	BOOL tailArrow;		//indicates if tail arrowhead is visible
	
}            

- init;
- initWithHead:(Socket *)aSocket andTail:(Socket *)aSocket;
- insertPost:(Post *)post newConnections:(Connection **)tailConn :(Connection **)headConn;
- finishInit;
- setColor:(NXColor)aColor;
- (NXColor)color;
- setLineWidth:(float)width;
- (float)lineWidth;
- setLineType:(int)type;
- (int)lineType;
- setHeadArrowheadVisible:(BOOL)flag;
- (BOOL)isHeadArrowheadVisible;
- setTailArrowheadVisible:(BOOL)flag;
- (BOOL)isTailArrowheadVisible;
- setLabelFraction:(float)value;
- (float)labelFraction;
- setLabelOffset:(float)value;
- (float)labelOffset;
- matchAttributesOf:conn;
- setHead:(Socket *)socket1 andTail:(Socket *)socket2;
- computeFrame;
- mouseHitAtPoint:(NXPoint *)location;
- (Socket *)head;
- (Socket *)tail;
- (DiagramCell *)headCell;
- (DiagramCell *)tailCell;
- (Socket *)inSocket;
- (Socket *)outSocket;
- (DiagramCell *)inCell;
- (DiagramCell *)outCell;
- drawInDirtyRect:(NXRect *)rect;
- drawSelf;
- drawConnection;
- adjustLabel;
- computeOffset:(float *)dxp :(float *)dyp perpendicularTo:(float)DX :(float)DY;
- isConnectedBetween:(Socket *)socket1 :(Socket *)socket2;
- isConnectedToSocket:(Socket *)aSocket;
- isConnectedToCell:(DiagramCell *)aCell;
- isConnectedToInputOf:(DiagramCell *)aBlock;
- isConnectedToOutputOf:(DiagramCell *)aBlock;
- cellHasMoved:(DiagramCell *)aCell;
- updateConnection;
- moveBy:(NXCoord)dx :(NXCoord)dy;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- (const char *)getInspectorClassName;
@end