#import <appkit/appkit.h>
#import "DiagramItem.h"

@class Connection;

@interface DiagramCell:DiagramItem

{
	NXImage *cellImage;		//base image to be stored for this cell
	NXImage *imageCache;	//image to be drawn if different from cellImage
	BOOL needsRedrawing;	//flag indicating whether the imageCache needs redrawing
	int labelPosition;		//position of the label wrt the cell
	List *connectionList;	//connections to some socket in this cell
}

+ (NXImage *)classImage;		//returns a default image for this class
+ getClassFrame:(NXRect *)rect;	//returns a default frame rect for this class

- init;
- initImage:(NXImage *)anImage;
- initIcon:(const char *)iconName;
- setImage:(NXImage *)anImage;
- (NXImage *)image;
- initFrame:(const NXRect *)rect;
- alignToGrid:(float)grid;
- sizeToNatural;
- sizeTo:(NXCoord)width :(NXCoord)height;
- (BOOL)needsRedrawing;
- setNeedsRedrawing:(BOOL)flag;
- redrawImage;
- drawSelf;
- drawSelected;
- drawCellInRect:(NXRect *)rect;
- drawInDirtyRect:(NXRect *)rect;
- moveTo:(NXCoord)x :(NXCoord)y;
- moveCenterTo:(NXCoord)x :(NXCoord)y;
- moveBy:(NXCoord)dx :(NXCoord)dy;
- mouseHitAtPoint:(NXPoint *)location;
- adjustLabel;
- setLabelPosition:(int)position;
- (int)labelPosition;
- matchAttributesOf:cell;
- addConnection:(Connection *)aConnection;
- breakConnection:(Connection *)aConnection;
- (List *)connectionList;
- free;
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

@end