#import <appkit/appkit.h>

@class Diagram,UHLabel;

@interface DiagramItem:Object

#define UH_TOPLEFT 1
#define UH_TOPCENTER 2
#define UH_TOPRIGHT 3
#define UH_LEFT 4
#define UH_CENTER 5
#define UH_RIGHT 6
#define UH_BOTTOMLEFT 7
#define UH_BOTTOMCENTER 8
#define UH_BOTTOMRIGHT 9

{
	Diagram *diagram;			//diagram to which item belongs
	NXRect frameRect;	//frame rectangle, excluding the label
	id reference;		//ptr to object represented by this item, if any
	UHLabel *label;			//the item's label object
	int tag;			//a user-defined value
	BOOL isLabelVisible;	//flag indicating if label is to be drawn
	BOOL selected;		//flag indicating if item is selected
	char *name;			//name given to this item (generally a class name)
}

- init;
- (const char *)name;
- setName:(const char *)aName;
- setDiagram:(Diagram *)anObject;
- (Diagram *)diagram;
- drawSelf;
- setTag:(int) aNumber;
- (int)tag;
- setLabel:(const char *)aString;
- (const char *)label;
- matchAttributesOf:item;
- setLabelObject:(UHLabel *)aLabel;
- (UHLabel *)labelObject;
- mouseHit:(NXPoint *)location;
- mouseHitAtPoint:(NXPoint *)location;
- getFrame:(NXRect *)rect;
- getBBox:(NXRect *)rect;
- performDoubleClick;
- setLabelFont:(Font *)fontObj;
- (Font *)labelFont;
- setLabelColor:(NXColor)aColor;
- (NXColor)labelColor;
- setLabelTransparent:(BOOL)flag;
- (BOOL)isLabelTransparent;
- setLabelBordered:(BOOL)flag;
- (BOOL)isLabelBordered;
- setLabelVisible:(BOOL)flag;
- (BOOL)isLabelVisible;
- setSelected:(BOOL)flag;
- (BOOL)isSelected;
- adjustLabel;
- setReference:anObject;
- reference;
- (BOOL)intersectsRect:(NXRect *)rect;
- (BOOL)isContainedInRect:(NXRect *)rect;
- editLabel;
- labelEditingDidEnd:(UHLabel *)label;
- free;
- copyFromZone:(NXZone *)zone;
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

@end