#import <appkit/appkit.h>

@interface UHLabel:Object

#define UH_TOPLEFT 1
#define UH_TOPCENTER 2
#define UH_TOPRIGHT 3
#define UH_LEFT 4
#define UH_CENTER 5
#define UH_RIGHT 6
#define UH_BOTTOMLEFT 7
#define UH_BOTTOMCENTER 8
#define UH_BOTTOMRIGHT 9

{
	NXRect labelRect;
	id view;
	id textDelegate;
	Text *labelText;
	TextField *labelField;
	TextFieldCell *labelCell;
	NXImage *labelImage;
	float fixedX, fixedY;
	int fixedPoint;
}

- initInView:aView;
- setTextDelegate:anObject;
- setStringValue:(const char *)aString;
- (const char *)stringValue;
- setColor:(NXColor)aColor;
- (NXColor)color;
- setBordered:(BOOL)flag;
- (BOOL)isBordered;
- setFont:(Font *)font;
- (Font *)font;
- setBackgroundTransparent:(BOOL)flag;
- (BOOL)isBackgroundTransparent;
- mouseHit:(NXPoint *)location;
- textDelegate;
- setView:aView;
- view;
- drawSelf;
- beginEditing;
- textDidEnd:(Text *)textObj endChar:(unsigned short)c;
- textDidGetKeys:(Text *)textObj isEmpty:(BOOL)flag;
- textWillConvert:(Text *)textObj fromFont:oldFont toFont:newFont;
- move:(int)position to:(float)x :(float)y;
- moveBy:(float)dx :(float)dy;
- reposition;
- getFrame:(NXRect *)rect;
- write:(NXTypedStream *)ts;
- read:(NXTypedStream *)ts;

@end

@interface Object(UHLabelTextDelegate)
- labelEditingDidBegin:self;
- labelEditingDidEnd:self;
@end